--------------------------------------------------------------------------------
-- Company: Trenz Electronic GmbH
-- Engineer: Antti Lukats, John Hartfiel
--
-- TE0790 CPLD U1 
--
--
-- Revision     : REV01
-- Release Date : 2017.04.26
-- Supported PCB Revision: 02
--
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library machxo2;
use machxo2.all;


ENTITY top IS
   PORT (
    -- FTDI Channel A, used normally as JTAG/MPSSE
		ADBUS0         		: IN std_logic;   -- ADBUS0 M_TCK
		ADBUS1	       		: IN std_logic;   -- ADBUS1 M_TDI > TDO
		ADBUS2         		: OUT std_logic;  -- ADBUS2 M_TDO < TDI
		ADBUS3         		: IN std_logic;   -- ADBUS3 M_TMS
		
		-- ADBUS4         		: IN std_logic;   
		-- ACBUS4         		: IN std_logic;  
		-- ACBUS5         		: IN std_logic;   
		
   -- FTDI Channel B, used normally as  UART
		BDBUS0              : IN std_logic; -- TX from FTDI
		BDBUS1              : OUT std_logic; -- RX to FTDI	
		
		--BDBUS2              : IN std_logic; -- TX from FTDI
		--BDBUS3              : OUT std_logic; -- RX to FTDI	

   -- XMOD Pin header
		A	 		    	: OUT std_logic;
		B	 		    	: OUT std_logic;
		F	 		    	: OUT std_logic;
		E	 		    	: IN std_logic; 
		
		C	 		    	: IN std_logic;
		D	 		    	: OUT std_logic; 
		
		-- H	 		    	: IN std_logic;
		G	 		    	: IN std_logic;
    --others
	  -- XCLK	 		  : IN std_logic;
		ULED        : OUT std_logic
      );
END ENTITY top;
--
ARCHITECTURE translated OF top IS

	--GENERIC (NOM_FREQ: string := "24.18");
	
COMPONENT OSCH
	-- synthesis translate_off
	GENERIC (NOM_FREQ: string := "12.09");
	-- synthesis translate_on
	PORT ( STDBY :IN std_logic;
	OSC :OUT std_logic;
	SEDSTDBY :OUT std_logic);
END COMPONENT OSCH;

-- attribute NOM_FREQ : string;
-- attribute NOM_FREQ of OSCinst0 : label is "12.09";


-- signal osc_clk: std_logic;
-- signal clk: std_logic;
-- signal cnt: std_logic_vector(31 downto 0);
-- signal ULED_Blink: std_logic;

BEGIN
-- ---------------------
-- JTAG
	A 			<= ADBUS0; -- TCK
	B 			<= ADBUS3; -- TMS
	
	ADBUS2 		<= E;	   -- TDI
	F 			<= ADBUS1; -- TDO


-- ---------------------
	-- Channel B is UART
	D   	 	<= BDBUS0;
	BDBUS1   	<= C;
	
-- ---------------------
-- LED
ULED 	 <= not G;
-- ULED 	 <= E xor not G;
-- ULED 	 <= H;
	
-- ---------------------
-- Other Settings
--	BDBUS1   	<= BDBUS0;
--	G 			<= '1';	 -- CPLD
--  G 			<= '0';	 -- TE07xxx

-- ---------------------
-- internal

-- OSCInst0: OSCH
		-- -- synthesis translate_off
		-- GENERIC MAP ( NOM_FREQ => "12.09" )
		-- -- synthesis translate_on
		-- PORT MAP (STDBY=> '0', OSC=> osc_clk, SEDSTDBY=> open);


-- process(XCLK)
-- begin
	-- if (rising_edge(XCLK)) then
			-- cnt <= cnt + X"00000001";
	-- end if;
-- end process;


END ARCHITECTURE translated;